Bug 827810 - Review Request: obnam - An easy, secure backup program
Review Request: obnam - An easy, secure backup program
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Paul Wouters
Fedora Extras Quality Assurance
:
Depends On: 827803 827804 827805 827806 827807 827808 827809 827819
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-03 02:32 EDT by Michel Alexandre Salim
Modified: 2013-02-17 01:10 EST (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-20 11:12:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
pwouters: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2012-06-03 02:32:20 EDT
Spec URL: http://salimma.fedorapeople.org/specs/admin/obnam.spec
SRPM URL: http://salimma.fedorapeople.org/specs/admin/obnam-1.0-1.fc17.src.rpm
Description:
Obnam is an easy, secure backup program. Backups can be stored on
local hard disks, or online via the SSH SFTP protocol. The backup
server, if used, does not require any special software, on top of SSH.

Some features that may interest you:

 * Snapshot backups. Every generation looks like a complete snapshot,
   so you don't need to care about full versus incremental backups, or
   rotate real or virtual tapes.

 * Data de-duplication, across files, and backup generations. If the
   backup repository already contains a particular chunk of data, it
   will be re-used, even if it was in another file in an older backup
   generation. This way, you don't need to worry about moving around
   large files, or modifying them.

 * Encrypted backups, using GnuPG.

Obnam can do push or pull backups, depending on what you need. You can
run Obnam on the client, and push backups to the server, or on the
server, and pull from the client over SFTP. However, access to live
data over SFTP is currently somewhat limited and fragile, so it is not
recommended.

Fedora Account System Username: salimma
Comment 1 Michel Alexandre Salim 2012-06-03 02:35:29 EDT
There's a yum repository for F-17 x86_64, for testing convenience, here:

http://hircus.multics.org/yum-repos/obnam.repo (repo file for /etc/yum.repos.d/)
http://hircus.multics.org/yum-repos/obnam (repo URL)
Comment 2 Neal Becker 2012-06-07 07:11:44 EDT
Above link seems broken:

You don't have permission to access /yum-repos/obnam.repo on this server
Comment 3 Ben Boeckel 2012-06-07 11:13:55 EDT
Fixing the component (while adding myself to CC). Is there a bug with the new version with component reassignment? (It got reset on a bug I commented on without manual changing recently as well.)
Comment 4 Michel Alexandre Salim 2012-06-07 15:10:42 EDT
(In reply to comment #2)
> Above link seems broken:
> 
> You don't have permission to access /yum-repos/obnam.repo on this server

permission fixed, thanks.
Comment 5 Michel Alexandre Salim 2012-06-07 15:14:03 EDT
i've seen bugs mysteriously assigned to 0xFFFF in the past too -- and sometimes during initial page load, the component is initially displayed as 0xFFFF and then jumps to the correct entry.

Could it just be a time out? If the right component never gets selected and you then submit a comment, presumably the wrong setting is then persisted (must be a common enough problem, that's why we even have a catch-all 0xFFFF component in the first place).
Comment 6 Ben Boeckel 2012-06-07 16:41:13 EDT
It's not a catch-all. http://koji.fedoraproject.org/koji/packageinfo?packageID=7065
Comment 7 Ben Boeckel 2012-06-07 18:09:25 EDT
Up for trading for Bug #829116? If so, assign me to one of the dependencies (I also have Haskell packages if you're up for more trades for the deps).
Comment 8 Michel Alexandre Salim 2012-06-08 12:07:51 EDT
Hi Ben,

Cc:ing myself there, but as Matthew promised to try and review over the weekend (though he's not claimed the review flag) I'll give him first dibs for now. Which Haskell packages do you want reviewed?

As for my requests, there's this one, 827806 (cmdtest), 827808 (python-larch), and  827723 (gnuhealth -- probably should be renamed to trytond-gnuhealth)

Thanks!
Comment 9 Ben Boeckel 2012-06-08 20:32:51 EDT
Bugs #630221, #630228, and #630258 seem to have the same deps as when I filed them (lots of my other ones have added deps since then; 40+ RRs still need filed yet). I'll take a look at cmdtest and larch to start. gnuhealth might be outside my ability to test properly.
Comment 10 Michel Alexandre Salim 2012-06-25 05:55:36 EDT
Updated spec and SRPM, cleaning up an unnecessary %%{python_sitelib} declaration and using upstream's check script

Spec URL: http://salimma.fedorapeople.org/specs/admin/obnam.spec
SRPM URL: http://salimma.fedorapeople.org/specs/admin/obnam-1.0-2.fc17.src.rpm
Comment 11 Neal Becker 2012-07-11 07:04:02 EDT
Any chance of update to 1.1?
Comment 12 Ben Boeckel 2012-07-20 01:00:38 EDT
Hrm, seems I had misinterpreted your comment about "Matthew promised to try and review over the weekend" as a Matthew had promised to review obnam, not ninja-build. He's not sponsored, so he couldn't claim it (he's a co-worker, so there was out-of-band communication there). I'll take this.
Comment 13 Ben Boeckel 2012-07-20 21:05:33 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint output is silent.
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/boeckb/misc/code/review/827810/obnam_1.0.orig.tar.gz :
  MD5SUM this package     : 4fdfc23ac8636d045502c99a12ffdbed
  MD5SUM upstream package : 4fdfc23ac8636d045502c99a12ffdbed

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[-]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[!]: SHOULD Latest version is packaged.

1.1 is out.

[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


Generated by fedora-review 0.1.3
External plugins:

Just need to update to 1.1 (doable when importing). Will approve once that is done.
Comment 14 Michel Alexandre Salim 2012-09-15 09:12:15 EDT
Updated:
http://salimma.fedorapeople.org/specs/admin/obnam.spec
http://salimma.fedorapeople.org/specs/admin/obnam-1.1-1.fc17.src.rpm

I've requested Git branches for the remaining dependencies -- apologies for the delay, new job is leaving me with less free time than expected.
Comment 15 Michel Alexandre Salim 2012-09-21 22:11:17 EDT
Ben, when you get your Internet connection back, please take a look -- thanks in advance.
Comment 16 Paul Wouters 2012-10-14 15:09:13 EDT
Looks like 1.2 got released, please package that version.

The source url is a little strange. Upstream does post a link to a debian repository, but on its own site, The spec file points to the general debian mirror page. The debian "orig" also causes some false positives in the review. This is not a problem.

The package is APPROVED



Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package contains BR: python2-devel or python3-devel
See: http://fedoraproject.org/wiki/Packaging:Python#BuildRequires


===== MUST items =====

C/C++:
[ ]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[ ]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[ ]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or generated". 3 files
     have unknown license. Detailed output of licensecheck in
     /home/paul/827810-obnam/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[ ]: Useful -debuginfo package or justification otherwise.

Python:
[!]: Package contains BR: python2-devel or python3-devel
===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: Package functions as described.
[!]: Latest version is packaged.
     Please ship version 1.2
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (obnam_1.1.orig.tar.gz)
[x]: SourceX is a working URL.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: obnam-debuginfo-1.1-1.fc17.x86_64.rpm
          obnam-1.1-1.fc17.x86_64.rpm
          obnam-1.1-1.fc17.src.rpm
obnam-debuginfo.x86_64: E: backup-file-in-package /usr/src/debug/obnam_1.1.orig
obnam.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
obnam.x86_64: W: no-manual-page-for-binary obnam-viewprof
obnam.src: W: spelling-error %description -l en_US de -> DE, ed, d
3 packages and 0 specfiles checked; 1 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint obnam obnam-debuginfo
obnam.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
obnam.x86_64: W: no-manual-page-for-binary obnam-viewprof
obnam-debuginfo.x86_64: E: backup-file-in-package /usr/src/debug/obnam_1.1.orig
2 packages and 0 specfiles checked; 1 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
obnam-debuginfo-1.1-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):


obnam-1.1-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):

    /usr/bin/python
    attr
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi) = 2.7
    python-cliapp
    python-larch
    python-paramiko
    python-tracing
    python-ttystatus
    rtld(GNU_HASH)

Provides
--------
obnam-debuginfo-1.1-1.fc17.x86_64.rpm:

    obnam-debuginfo = 1.1-1.fc17
    obnam-debuginfo(x86-64) = 1.1-1.fc17

obnam-1.1-1.fc17.x86_64.rpm:

    obnam = 1.1-1.fc17
    obnam(x86-64) = 1.1-1.fc17



Unversioned so-files
--------------------
obnam-1.1-1.fc17.x86_64.rpm: /usr/lib64/python2.7/site-packages/obnamlib/_obnam.so

MD5-sum check
-------------
http://ftp.debian.org/debian/pool/main/o/obnam/obnam_1.1.orig.tar.gz :
  CHECKSUM(SHA256) this package     : 763693e5ea4e8d6a63b1a16c2aacd5fe0dc97abc687c8f0dde5840f77d549349
  CHECKSUM(SHA256) upstream package : 763693e5ea4e8d6a63b1a16c2aacd5fe0dc97abc687c8f0dde5840f77d549349


Generated by fedora-review 0.3.0 (c78e275) last change: 2012-09-24
Buildroot used: fedora-17-x86_64
Command line :/usr/bin/fedora-review -b 827810
Comment 17 Michel Alexandre Salim 2012-10-16 05:53:12 EDT
New Package SCM Request
=======================
Package Name: obnam
Short Description: An easy, secure backup program
Owners: salimma
Branches: el6 f17 f18
InitialCC:
Comment 18 Michel Alexandre Salim 2012-10-16 05:55:02 EDT
@ Paul

Thanks! Yes, will be packaging 1.2, and I'm gradually switching over all the source URLs to Debian mirrors.
Comment 19 Gwyn Ciesla 2012-10-16 07:55:41 EDT
Git done (by process-git-requests).
Comment 20 Fedora Update System 2012-10-17 02:38:36 EDT
obnam-1.2-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/obnam-1.2-1.fc17
Comment 21 Fedora Update System 2012-10-17 02:38:49 EDT
obnam-1.2-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/obnam-1.2-1.fc18
Comment 22 Fedora Update System 2012-10-17 13:36:01 EDT
obnam-1.2-1.fc18 has been pushed to the Fedora 18 testing repository.
Comment 23 Fedora Update System 2012-10-18 21:58:14 EDT
obnam-1.2-1.el6,summain-0.14-2.el6,python-larch-1.20121006-1.el6,python-tracing-0.6-2.el6,genbackupdata-1.6-2.el6,python-cliapp-1.20120630-1.el6,python-ttystatus-0.19-1.el6,python-coverage-test-runner-1.8-1.el6,cmdtest-0.3-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/obnam-1.2-1.el6,summain-0.14-2.el6,python-larch-1.20121006-1.el6,python-tracing-0.6-2.el6,genbackupdata-1.6-2.el6,python-cliapp-1.20120630-1.el6,python-ttystatus-0.19-1.el6,python-coverage-test-runner-1.8-1.el6,cmdtest-0.3-3.el6
Comment 24 Anton Shevtsov 2012-11-07 12:47:45 EST
obnam does not work in CentOS6.
try simple command:

obnam backup --verbose --repository /tmp/OBNAM/ sftp://user@domain.tld/tmp/

you get is 'timeout lock' always
Comment 25 Ben Boeckel 2012-11-07 13:48:45 EST
This is probably a bug for upstream. Depends on what --verbose output I suppose.
Comment 26 Michel Alexandre Salim 2012-11-10 00:13:24 EST
Backing up a local directory to a local repository works, will try the remote case.

Now that obnam is in, it's probably still worth reporting such bugs in addition to contacting upstream, but perhaps open a new bug report instead of adding it to the review?
Comment 27 Fedora Update System 2012-12-20 11:12:20 EST
obnam-1.2-1.el6, summain-0.14-2.el6, python-larch-1.20121006-1.el6, python-tracing-0.6-2.el6, genbackupdata-1.6-2.el6, python-cliapp-1.20120630-1.el6, python-ttystatus-0.19-1.el6, python-coverage-test-runner-1.8-1.el6, cmdtest-0.3-3.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 28 Nick 2013-02-17 01:10:19 EST
It's upstream bug because we use old python-paramiko.
But it can be fixed by this patch:

--- obnamlib/plugins/sftp_plugin.py	2012-12-17 02:42:08.000000000 +0400
+++ obnamlib/plugins/sftp_plugin.py	2013-02-17 09:58:02.267473954 +0400
@@ -151,6 +151,7 @@
             self._connect_paramiko()
         if self.create_path_if_missing:
             self._create_root_if_missing()
+        self.chdir(self.path)
         self._initial_dir = self.getcwd()
         self.chdir(self.path)

Note You need to log in before you can comment on or make changes to this bug.